/* ==========================================================================
*    : ̼
*    : 2007.01.17
*      :  
* ǻ : 
*===========================================================================*/
#pragma once

class cFileToRead;
class cFileToReadW;

///  
///     ֵ ش.
///  ý     ϴ.
class cFileLoader
{
public:
	cFileLoader();
	~cFileLoader();

	/// 
	bool Open( const cString& pathName, bool useMemory  );

	bool OpenNoPack( const cString& pathName, bool useMemory );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	int Close();

	/// Ÿ б
	///  о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	unsigned int Read( void* buffer, unsigned int bytes );

	/// ⺻ ڷ б
	bool ReadInt( int* value );
	bool ReadUnsignedInt( unsigned int* value );
	bool ReadFloat( float* value );

	///   б
	/// о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	/// :   ιڸ ߰ϹǷ ִ bufferSize-1 ŭ о δ.
	unsigned int ReadLine( char* buffer, unsigned int bufferSize );

	///  ġ ̵
	/// ϸ 0, ϸ -1 Ѵ.
	int Seek( unsigned int offset, int origin = SEEK_SET );

	///  ġ 
	/// ϸ 0 Ѵ.
	unsigned int Tell() const;

	///  ũ⸦ 
	unsigned int GetSize() const;

	///  
	cFileToRead* GetFile() const;

	/// ޸  ͸ 
	/// ޸𸮸  ʴ  0 
	const char* GetBufferPtr();

	///   ߴ θ 
	bool IsEnd() const;

	///   
	bool IsEmpty() const;

	/// ޸  θ 
	bool IsMemUsed() const;

private:
	/// ޸  
	bool mMemUsed;

	/// б  
	cFileToRead* mFile;
};

inline cFileToRead* cFileLoader::GetFile() const
{
	return mFile;
}

inline bool cFileLoader::IsMemUsed() const
{
	return mMemUsed;
}

//--------------------------------------------------------------------
class cFileLoaderW
{
public:
	cFileLoaderW();
	~cFileLoaderW();

	/// 
	bool Open( const cStringW& pathName, bool useMemory  );

	bool OpenNoPack( const cStringW& pathName, bool useMemory );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	int Close();

	/// Ÿ б
	///  о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	unsigned int Read( void* buffer, unsigned int bytes );

	/// ⺻ ڷ б
	bool ReadInt( int* value );
	bool ReadUnsignedInt( unsigned int* value );
	bool ReadFloat( float* value );

	///   б
	/// о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	/// :   ιڸ ߰ϹǷ ִ bufferSize-1 ŭ о δ.
	unsigned int ReadLine( wchar_t* buffer, unsigned int bufferSize );

	///  ġ ̵
	/// ϸ 0, ϸ -1 Ѵ.
	int Seek( unsigned int offset, int origin = SEEK_SET );

	///  ġ 
	/// ϸ 0 Ѵ.
	unsigned int Tell() const;

	///  ũ⸦ 
	unsigned int GetSize() const;

	///  
	cFileToReadW* GetFile() const;

	/// ޸  ͸ 
	/// ޸𸮸  ʴ  0 
	const wchar_t* GetBufferPtr();

	///   ߴ θ 
	bool IsEnd() const;

	///   
	bool IsEmpty() const;

	/// ޸  θ 
	bool IsMemUsed() const;

private:
	/// ޸  
	bool mMemUsed;

	/// б  
	cFileToReadW* mFile;
};

inline cFileToReadW* cFileLoaderW::GetFile() const
{
	return mFile;
}

inline bool cFileLoaderW::IsMemUsed() const
{
	return mMemUsed;
}