/* ==========================================================================
*    : ̼
*    : 2007.02.21
*      :  м
* ǻ : 
*===========================================================================*/
#pragma once

class cToken;
class cMemFileToRead;

class cTokenW;
class cMemFileToReadW;

/// ʰ  м
/// ؽƮ    м̴.
class cLexer
{
public:
	cLexer();
	cLexer( cMemFileToRead* pfile );
	cLexer( const char* pbuffer, unsigned int size );
	virtual ~cLexer();

	/// ҽ 
	virtual void SetSource( cMemFileToRead* pfile );
	virtual void SetSource( const char* pbuffer, unsigned int size );

	///  ū 
	/// ڷ ѱ ū ( Ÿ, ٹȣ  ) ϰ, ū Ÿ Ѵ.
	virtual int GetNextToken( cToken* ptoken );

	///  ū ڿ 
	///  ˻ ϰ ٷ ڿ Ѵ.
	virtual int GetNextString( cToken* ptoken );

	/// Ű ū Ÿ 
	/// Ű尡 ƴϸ TOKEN_VAR Ѵ.
	virtual int GetTokenType( const cString& keyword );

	///  θ 
	virtual bool IsEnd();

protected:
	///  ڸ ϰ  ġ ̵
	char GetNextChar();

	///  ڸ 
	void UngetNextChar();

	/// Ű忡 ū Ÿ 
	void BindKeyword( const cString& keyword, int tokenType );

protected:
	///  
	const char* mpBuffer;

	///  
	unsigned int mBufferLen;

	/// ڸ  ġ
	unsigned int mPos;

	///  ȣ
	int mLine;

	/// Ű 
	typedef tHashMap<cString, int> cKeywordMap;
	cKeywordMap mKeywordMap;
};


//---------------------------------------------------------------------
class cLexerW
{
public:
	cLexerW();
	cLexerW( cMemFileToReadW* pfile );
	cLexerW( const wchar_t* pbuffer, unsigned int size );
	virtual ~cLexerW();

	/// ҽ 
	virtual void SetSource( cMemFileToReadW* pfile );
	virtual void SetSource( const wchar_t* pbuffer, unsigned int size );

	///  ū 
	/// ڷ ѱ ū ( Ÿ, ٹȣ  ) ϰ, ū Ÿ Ѵ.
	virtual int GetNextToken( cTokenW* ptoken );

	///  ū ڿ 
	///  ˻ ϰ ٷ ڿ Ѵ.
	virtual int GetNextString( cTokenW* ptoken );

	/// Ű ū Ÿ 
	/// Ű尡 ƴϸ TOKEN_VAR Ѵ.
	virtual int GetTokenType( const cStringW& keyword );

	///  θ 
	virtual bool IsEnd();

protected:
	///  ڸ ϰ  ġ ̵
	wchar_t GetNextChar();

	///  ڸ 
	void UngetNextChar();

	/// Ű忡 ū Ÿ 
	void BindKeyword( const cStringW& keyword, int tokenType );

protected:
	///  
	const wchar_t* mpBuffer;

	///  
	unsigned int mBufferLen;

	/// ڸ  ġ
	unsigned int mPos;

	///  ȣ
	int mLine;

	/// Ű 
	typedef tHashMap<cStringW, int> cKeywordMap;
	cKeywordMap mKeywordMap;
};
