/* ==========================================================================
*    : ̼
*    : 2007.02.06
*      : std::hashtable   ؽø ø
* ǻ :  Ͱ Ұ Ǵ   ʴ´.
*===========================================================================*/
#pragma once

#pragma warning( push )
#pragma warning( disable: 4267 )
#pragma warning( disable: 4311 )
//#pragma warning( disable: 4996 )
#include <hash_map>
#include "Hasher.h"
#include "Pair.h"
#include "Functor.h"

using namespace std;

///  ؽ 
/// Ű/  ϳ ҷ ϴ ̴̳.
/// ߺ Ű  ʴ´.
///  Ͱ Ұ Ǵ   ʴ´.
template <class KEY, class T, class HASHER = tHasher<KEY>, class EQUAL = tBinaryEqual<KEY> >
class tPointerHashMap
{
public:
	typedef typename tPair<KEY, T> cPair;

private:
	typedef tPointerHashMap<KEY, T, HASHER, EQUAL> cSelf;
	typedef _STLP_PRIV _HashMapTraitsT<cPair> _HashMapTraits;
	typedef hashtable<cPair, KEY, HASHER, _HashMapTraits, tSelect1st<cPair>, EQUAL, allocator<cPair> > cTable;

public:
	typedef typename cTable::iterator cIterator;
	typedef typename cTable::const_iterator cConstIterator;
	typedef typename cTable::hasher cHasher;
	typedef typename cTable::key_equal cKeyEqual;
	typedef typename cTable::allocator_type cAllocatorType;

private:
	/// ؽ ̺
	cTable mTable;

public:
	/*
	tPointerHashMap();
	explicit tPointerHashMap( unsigned int hint );

	///  ҵ 
	void Clear();

	/// ؽ ̺ Ŷ ũ⸦ 
	void Resize( unsigned int hint );

	///  Ű   ġ 
	cIterator Find( const KEY& key );
	cConstIterator Find( const KEY& key) const;

	/// ش Ű  
	/// ϸ false Ѵ.
	bool Insert( const KEY& key, const T val );

	/// ش Ű  Ҹ 
	/// ŵ   Ѵ.
	unsigned int Erase( const KEY& key );

	/// posġ Ҹ 
	void Erase( cIterator pos );

	/// [first, last)  ҵ 
	void Erase( cIterator first, cIterator last );

	/// ݺڸ 
	cIterator Begin();
	cConstIterator Begin() const;
	cIterator End();
	cConstIterator End() const;

	/// key شϴ  
	/// ϸ false Ѵ.
	bool GetAt( T* val, const KEY& key ) const;
	T GetAt( const KEY& key ) const;

	///  key    
	unsigned int GetCount( const KEY& key ) const;

	///   
	unsigned int GetSize() const;

	/// ִ θ 
	bool IsEmpty() const;

	///  
	/// :   Ұ!   뵵θ ϰ   ִ.
	T operator [] ( const KEY& key );

	/// : ϸ ߱  Ƿ ؼ Ѵ.
	tPointerHashMap( const cSelf& other );
	*/

private:
	cSelf& operator = ( const cSelf& other );

#	include "PointerHashMap.inl"
};

#pragma warning( pop )
