/* ==========================================================================
*    : ̼
*    : 2006.12.04
*      :   ó
* ǻ : 
*===========================================================================*/
#pragma once

///  θ 
/// : "c:/mydir/myfile.ext"
/// : "c:/mydir/"
bool GetFilePath( cString* out, const cString& str);
bool GetFilePath( cStringW* out, const cStringW& str);

///  ̸ 
/// : "c:/mydir/myfile.ext"
/// : "myfile.ext"
bool GetFileName( cString* out, const cString& str);

///  Ȯڸ 
/// : "c:/mydir/myfile.ext"
/// : "ext"
bool GetFileExtension( cString* out, const cString& str);
cString GetFileExtension( const cString& str);
cString GetFileExtension( const char* str,  unsigned int strLen );

///   
bool FileExist( const cString& pathName );
bool FileExist( const cStringW& pathName );

///  
bool FileRemove( const cString& pathName );

///  ̸ 
bool FileRename( const cString& oldName, const cString& newName );

///  
bool FileBackup( const cString& pathName );

/// б  
class cFileToRead
{
public:
	cFileToRead();
	virtual ~cFileToRead();

	/// 
	virtual bool Open( const cString& pathName );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Close();

	/// Ÿ б
	///  о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	virtual unsigned int Read( void* buffer, unsigned int bytes );

	///   б
	/// о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	/// :   ιڸ ߰ϹǷ ִ bufferSize-1 ŭ о δ.
	virtual unsigned int ReadLine( char* buffer, unsigned int bufferSize );

	///  ġ ̵
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Seek( unsigned int offset, int origin = SEEK_SET );

	///  ġ 
	/// ϸ 0 Ѵ.
	virtual unsigned int Tell() const;

	///  ũ⸦ 
	virtual unsigned int GetSize() const;

	///   ߴ θ 
	virtual bool IsEnd() const;

	///   
	bool IsEmpty() const;

//protected:
	///  
	unsigned int mSize;

	///  ü
	FILE* mFile;
};

inline bool cFileToRead::IsEmpty() const
{
	return mSize == 0;
}

///   
class cFileToWrite
{
public:
	cFileToWrite();
	virtual ~cFileToWrite();

	/// 
	virtual bool Open( const cString& pathName );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Close();

	/// Ÿ 
	///   Ÿ ũ⸦ Ѵ. ϸ 0 Ѵ.
	virtual unsigned int Write( const void* buffer, unsigned int bytes );

	/// Ÿ  
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Flush();

protected:
	///  ü
	FILE* mFile;
};

//-------------------------------------------------------

class cFileToReadW
{
public:
	cFileToReadW();
	virtual ~cFileToReadW();

	/// 
	virtual bool Open( const cStringW& pathName );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Close();

	/// Ÿ б
	///  о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	virtual unsigned int Read( void* buffer, unsigned int bytes );

	///   б
	/// о  Ʈ  Ѵ.
	/// ϰų   ϸ 0 Ѵ.
	/// :   ιڸ ߰ϹǷ ִ bufferSize-1 ŭ о δ.
	virtual unsigned int ReadLine( wchar_t* buffer, unsigned int bufferSize );

	///  ġ ̵
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Seek( unsigned int offset, int origin = SEEK_SET );

	///  ġ 
	/// ϸ 0 Ѵ.
	virtual unsigned int Tell() const;

	///  ũ⸦ 
	virtual unsigned int GetSize() const;

	///   ߴ θ 
	virtual bool IsEnd() const;

	///   
	bool IsEmpty() const;

	//protected:
	///  
	unsigned int mSize;

	///  ü
	FILE* mFile;
};

inline bool cFileToReadW::IsEmpty() const
{
	return mSize == 0;
}

///   
class cFileToWriteW
{
public:
	cFileToWriteW();
	virtual ~cFileToWriteW();

	/// 
	virtual bool Open( const cStringW& pathName );

	/// ݱ
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Close();

	/// Ÿ 
	///   Ÿ ũ⸦ Ѵ. ϸ 0 Ѵ.
	virtual unsigned int Write( const void* buffer, unsigned int bytes );

	/// Ÿ  
	/// ϸ 0, ϸ -1 Ѵ.
	virtual int Flush();

protected:
	///  ü
	FILE* mFile;
};
