/* ==========================================================================
*    : ̼
*    : 2007.02.06
*      : std::hashtable   ؽÙV ø
* ǻ :  Ͱ Ұ Ǵ   ʴ´.
*===========================================================================*/
#pragma once

#pragma warning( push )
#pragma warning( disable: 4267 )
#pragma warning( disable: 4311 )
//#pragma warning( disable: 4996 )
#include <hash_set>
#include "Hasher.h"
#include "Functor.h"

using namespace std;

///  ؽ V
/// ߺ Ű  ʴ´.
///  Ͱ Ұ Ǵ   ʴ´.
template<class T, class HASHER = tHasher<T>, class EQUAL = tBinaryEqual<T> >
class tPointerHashSet
{
	typedef tPointerHashSet<T, HASHER, EQUAL> cSelf;
	typedef _STLP_PRIV _HashSetTraitsT<T> _HashSetTraits;
	typedef hashtable<T, T, HASHER, _HashSetTraits, tIdentity<T>, EQUAL, allocator<T> > cTable;

public:
	typedef typename cTable::iterator cIterator;
	typedef typename cTable::const_iterator cConstIterator;
	typedef typename cTable::hasher cHasher;
	typedef typename cTable::key_equal cKeyEqual;
	typedef typename cTable::allocator_type cAllocatorType;

private:
	/// ؽ ̺
	cTable mTable;

public:
	/*
	tPointerHashSet();
	explicit tPointerHashSet( unsigned int hint );

	///  ҵ 
	void Clear();

	/// ؽ ̺ Ŷ ũ⸦ 
	void Resize( unsigned int hint );

	///     ġ 
	cIterator Find( const T val );
	cConstIterator Find( const T val) const;

	///  
	/// ϸ false Ѵ.
	bool Insert( const T val );

	/// ش   Ҹ 
	/// ŵ   Ѵ.
	unsigned int Erase( const T val );

	/// posġ Ҹ 
	void Erase( cIterator pos );

	/// [first, last)  ҵ 
	void Erase( cIterator first, cIterator last );

	/// ݺڸ 
	cIterator Begin();
	cConstIterator Begin() const;
	cIterator End();
	cConstIterator End() const;

	///      
	unsigned int GetCount( const T val ) const;

	///   
	unsigned int GetSize() const;

	/// ִ θ 
	bool IsEmpty() const;

	/// : ϸ ߱  Ƿ ؼ Ѵ.
	tPointerHashSet( const cSelf& other );
	*/

private:
	cSelf& operator = ( const cSelf& other );

#	include "PointerHashSet.inl"
};

#pragma warning( pop )
