/* ==========================================================================
*    : ̼
*    : 2006.12.06
*      : std::list   Ʈ ø
* ǻ :  Ͱ Ұ Ǵ   ʴ´.
*===========================================================================*/
#pragma once

#pragma warning( push )
//#pragma warning( disable: 4996 )
#pragma warning( disable: 4267 )
#include <list>

using namespace std;

template <class T, _STLP_DEFAULT_ALLOCATOR_SELECT(T) >
class tPointerList;

///  Ʈ
///  Ͱ Ұ Ǵ   ʴ´.
template<class T, class ALLOC>
class tPointerList : protected list<T, ALLOC>
{
	typedef list<T, ALLOC> list;
	typedef tPointerList<T, ALLOC> cSelf;

public:
	typedef list::iterator cIterator;
	typedef list::const_iterator cConstIterator;

public:
	/*
	explicit tPointerList();

	///  Ҹ 
	void Clear();

	/// pos ġ Ҹ 
	/// ο  ġ Ѵ.
	cIterator Insert( cIterator pos, const T val );

	///  տ Ҹ ߰
	bool PushFront( const T val );

	///  ڿ Ҹ ߰
	bool PushBack( const T val );

	/// pos ġ Ҹ 
	///   ġ Ѵ.
	cIterator Erase( cIterator pos );

	/// [first, last)   Ҹ 
	///   ġ Ѵ.
	cIterator Erase( cIterator first, cIterator last );

	///   Ҹ 
	void PopFront();

	///   Ҹ 
	void PopBack();

	/// Ʈ other  Ҹ pos ġ  ̵
	void Splice( cIterator pos, cSelf& other );

	/// Ʈ other [first, last)   Ҹ pos ġ  ̵
	void Splice( cIterator pos, cSelf& other, cIterator first, cIterator last );

	/// Ʈ other i ִ Ҹ pos ġ  ̵
	void Splice( cIterator pos, cSelf& other, cIterator i );

	///  val  Ҹ 
	void Remove( const T val );

	/// Լ op true ϴ  Ҹ 
	template<class Predicate>
	void RemoveIf( Predicate op );

	/// < ڸ   
	void Sort();

	/// Լ op  
	template<class StrictWeakOrdering>
	void Sort( StrictWeakOrdering op );

	/// ݺڸ 
	cIterator Begin();
	cConstIterator Begin() const;
	cIterator End();
	cConstIterator End() const;

	/// Ҹ 
	T& Front();
	const T& Front() const;
	T& Back();
	const T& Back() const;

	///   
	unsigned int GetSize() const;

	/// ִ θ 
	bool IsEmpty() const;

	/// : ϸ ߱  Ƿ ؼ Ѵ.
	tPointerList( const cSelf& other );
	*/

private:
	cSelf& operator = ( const cSelf& other );

private:
	/// : Ʒ Լ  󵵰 ų ϸ ߱ϹǷ  !

	///  ҵ  ڹٲ
	void Reverse();

	///    ӵ ҵ ߺ 
	/// ) 1, 2, 3, 3, 4, 3 -> 1, 2, 3, 4, 3
	void Unique();

	/// op true ϴ ӵ ҵ ߺ 
	template<class BinaryPredicate>
		void Unique( BinaryPredicate op );

	/// ̹ ĵ  Ʈ Լ op   
	template<class StrictWeakOrdering>
		void Merge( cSelf& other, StrictWeakOrdering op );

#	include "PointerList.inl"
};

#pragma warning( pop )
